Subject: [dnssd] DNSSD at IETF 106 Hackathon

From: Stuart Cheshire <[email-masked]>
Date: Tue, 12 Nov 2019 19:49:46 -0800

I’m planning to be at the IETF 106 Hackathon. At previous Hackathons Ted Lemon has been my hacking companion, but right now Ted is too busy with other work to make it to IETF this time. If you’re interested in collaborating on some DNSSD coding on Saturday at the Hackathon, please let me know.

I’ve offered to host some hands-on “Code Clinic” coding sessions at the Hackathon, to show people how to take their existing code where a human user enters a hostname or IP address, and enhance it by adding service discovery using DNSSD APIs.

If you know some software that could benefit from having some service discovery added, please evangelize this opportunity to them. Here is the description as currently listed on the Hackathon wiki:

<https://trac.ietf.org/trac/ietf/meeting/wiki/106hackathon#DNSSD>

> Service Discovery Code Clinic. If your application has any place where a human user enters a hostname or IP address, come by for hands-on help updating your application to use network service discovery to improve that user experience. We can help you do this using the APIs available on Windows, Android, Linux, macOS, and iOS. If you’re using another platform, we can help you port the open source mDNSResponder code to that platform too. Please email Stuart Cheshire with “Code Clinic” in the subject line to arrange a time slot.

I’ve also volunteered to give a tutorial, 13:45-14:45 on Sunday, on the same topic. As above, if you know some software that could be improved by adding service discovery, please evangelize this tutorial to people you think could benefit from learning more about this. The full description is attached below.

Stuart Cheshire

--

Title: Service Discovery for IP applications

Abstract: If your application has any place where a human user enters a hostname or IP address, or uses broadcast to discover the address of a device, come to this tutorial to learn how you can use network service discovery to improve that user experience.

Description:

Many IP applications today are still configured manually. Sometimes a human user needs to enter a hostname or IP address in a configuration file or user-interface field. Sometimes software will use its own ad hoc broadcast-based discovery mechanism to learn the IP address of the peer with which it wishes to communicate. In both cases, using the IETF’s standard DNS-based service discovery mechanism, defined in RFC 6763, provides better user experience and more efficient use of the network.

In this tutorial we will cover the APIs available on Windows, Android, Linux, macOS, and iOS, that facilitate the three fundamental operations of DNS-based service discovery: Offer, Enumerate, and Use.

Sometimes the “use” step may be performed multiple times, as in the case of printing on a network printer. In other cases, the “enumerate” and “use” steps are performed just once, for the purpose of one-time provisioning and configuration of a new device added to the network.

This tutorial covers both local service discovery using Multicast DNS, defined in RFC 6762, and wide area service discovery using conventional unicast DNS, both via manual configuration of DNS servers (as is done for printing at IETF meetings) and via automation tools like a Discovery Proxy (defined in draft-ietf-dnssd-hybrid).

For those arriving early, we will be holding service discovery “code clinic” hours at the IETF 106 Hackathon on Saturday. Come by for hands-on help updating your application to use network service discovery.